/* Memory mapper header */

#ifndef HEADER_MEMMAP_H
#define HEADER_MEMMAP_H

#include "z80.h"

#define BLOCK_TOTAL 64
#define BLOCK_SIZE 0x8000
#define BLOCK_HIGH block00

#define BANK_NOROMS B8(00000100)
#define BANK_ROM3 B8(00100000)
#define BANK_VRAM B8(00001000)
#define BANK_VADD B8(00010000)

#define BANK_CF_PC85 B8(10000000)

#define MAXMEMHANDLERS 20

int memmap_init (void);
int memmap_deinit (void);
int memmap_reset (void);
void memmap_init6264 (char *mem, int banks);
void memmap_init6116 (char *mem, int banks);
void memmap_init6264 (char *mem, int banks);
void memmap_mode1 (uint16_t port, uint8_t data, struct z80_port_write *port_struct);
void memmap_mode2 (uint16_t port, uint8_t data, struct z80_port_write *port_struct);
char *memmap_get_z80_ptr (int addr);
void memmap_configure (void);

#endif  /* HEADER_MEMMAP_H */
