/* z80 Header */

#ifndef HEADER_Z80_H
#define HEADER_Z80_H

#include <stdint.h>

int z80_init (void);
int z80_deinit (void);
int z80_reset (void);
void z80_cf_ports (void);
void z80_hdd_ports (void);
void z80_set_port_58h (void);

struct z80_memory_read_byte
{
 uint32_t low_addr;
 uint32_t high_addr;
 uint8_t (*memory_call)(uint32_t, struct z80_memory_read_byte *);
 void *p_user_area;
};

struct z80_memory_write_byte
{
 uint32_t low_addr;
 uint32_t high_addr;
 void (*memory_call)(uint32_t, uint8_t, struct z80_memory_write_byte *);
 void *p_user_area;
};

struct z80_port_read
{
 uint16_t low_addr;
 uint16_t high_addr;
 uint16_t (*io_call)(uint16_t, struct z80_port_read *);
 void *p_user_area;
};      

struct z80_port_write
{
 uint16_t low_addr;
 uint16_t high_addr;
 void (*io_call)(uint16_t, uint8_t, struct z80_port_write *);
 void *p_user_area;
};

#endif /* HEADER_Z80_H */
